<template>
  <v-container>
    <v-layout row wrap class="justify-center">
      <v-flex xs12 sm10 md8 lg7 xl6>
        <v-layout fill-height column>
          <v-flex xs4>
            <v-layout row wrap>
              <v-flex xs6>
                <v-img :src="graphImage"></v-img>
              </v-flex>
              <v-flex xs6>
                <v-img :src="matrixImage"></v-img>
              </v-flex>
            </v-layout>
          </v-flex>
          <v-flex xs8>
            <v-layout row wrap>
              <v-flex xs12 class="pt-3">
                <p class="display-1 font-weight-medium">{{ doc.title }}</p>
              </v-flex>
              <v-flex xs12>
                <p class="title font-weight-medium">
                  Visualization of
                  <span class="primary--text">{{ doc.datasetName }}</span>
                </p>
              </v-flex>
              <v-flex xs12>
                <p class="title font-weight-medium">
                  by
                  <span class="primary--text">{{ doc.author }}</span>
                  , {{ getTime(doc.timestamp) }}
                </p>
              </v-flex>
              <v-flex xs12 class="pt-3">
                <p class="h2">{{ doc.text || "Insight text" }}</p>
              </v-flex>
              <v-flex xs12 class="pa-0 pt-3">
                <v-btn color="primary" @click="navigateToVisualisation"
                  >View this dataset</v-btn
                >
              </v-flex>
            </v-layout>
          </v-flex>
        </v-layout>
      </v-flex>
    </v-layout>
  </v-container>
</template>

<script>
import { db, storage } from "@/firebase";
import moment from "moment";

export default {
  props: {
    id: String
  },
  data() {
    return {
      doc: {
        title: "Title of insight",
        datasetName: "Name of dataset",
        text: "Insight text"
      },
      matrixImage: undefined,
      graphImage: undefined
    };
  },
  methods: {
    getTime(timestamp) {
      if (timestamp) {
        const { seconds } = timestamp;
        return moment.unix(seconds).fromNow();
      }
    },
    navigateToVisualisation() {
      this.$store.commit("setCurrentDatasetId", {
        id: this.doc.dataset,
        name: this.doc.datasetName
      });
      this.$router.push("/visualisation");
    }
  },
  async created() {
    this.doc = await db
      .collection("insights")
      .doc(this.id)
      .get();
    this.doc = this.doc.data();

    this.matrixImage = await storage
      .ref(`insights/matrix_${this.id}.png`)
      .getDownloadURL();

    this.graphImage = await storage
      .ref(`insights/graph_${this.id}.png`)
      .getDownloadURL();
  }
};
</script>

<style></style>
